<?php

namespace Schaffen\BankIntegration\Cnab\Conciliacao\Cnab240;

use Carbon\Carbon;
use Schaffen\BankIntegration\Contracts\Cnab\Conciliacao\Cnab240\Header as HeaderContract;
use Schaffen\BankIntegration\MagicTrait;

class Header implements HeaderContract
{
    use MagicTrait;


     /**
     * @var integer
     */
    public $codBanco;

    /**
     * @var integer
     */
    public $loteServico;

    /**
     * @var string
     */
    public $tipoRegistro;

    /**
     * @var string
     */
    public $tipoInscricao;

    /**
     * @var string
     */
    public $numeroInscricao;

    /**
     * @var string
     */
    public $convenio;

    /**
     * @var string
     */
    public $agencia;

    /**
     * @var string
     */
    public $agenciaDv;

    /**
     * @var string
     */
    public $conta;

    /**
     * @var string
     */
    public $contaDv;

    /**
     * @var string
     */
    public $nomeEmpresa;
    
    /**
     * @var string
     */
    public $nomeBanco;

    /**
     * @var integer
     */
    public $codigoRemessaRetorno;

    /**
     * @var string
     */
    public $data;

    /**
     * @var string
     */
    public $hora;

    /**
     * @var string
     */
    public $numeroSequencialArquivo;

    /**
     * @var string
     */
    public $versaoLayoutArquivo;

    // /**
    //  * @var string
    //  */
    // protected $horaGeracao;

    

    /**
     * @return int
     */
    public function getCodBanco()
    {
        return $this->codBanco;
    }

    /**
     * @param int $codBanco
     *
     * @return $this
     */
    public function setCodBanco($codBanco)
    {
        $this->codBanco = $codBanco;

        return $this;
    }

    /**
     * @return integer
     */
    public function getLoteServico()
    {
        return $this->loteServico;
    }

    /**
     * @param integer $loteServico
     *
     * @return $this
     */
    public function setLoteServico($loteServico)
    {
        $this->loteServico = $loteServico;

        return $this;
    }

    /**
     * @return string
     */
    public function getTipoRegistro()
    {
        return $this->tipoRegistro;
    }

    /**
     * @param string $tipoRegistro
     *
     * @return $this
     */
    public function setTipoRegistro($tipoRegistro)
    {
        $this->tipoRegistro = $tipoRegistro;

        return $this;
    }

    /**
     * @return string
     */
    public function getTipoInscricao()
    {
        return $this->tipoInscricao;
    }

    /**
     * @param string $tipoInscricao
     *
     * @return $this
     */
    public function setTipoInscricao($tipoInscricao)
    {
        $this->tipoInscricao = $tipoInscricao;

        return $this;
    }

     /**
     * @return string
     */
    public function getNumeroInscricao()
    {
        return $this->numeroInscricao;
    }

    /**
     * @param string $numeroInscricao
     *
     * @return $this
     */
    public function setNumeroInscricao($numeroInscricao)
    {
        $this->numeroInscricao = $numeroInscricao;

        return $this;
    }

    
    /**
     * @return string
     */
    public function getConvenio()
    {
        return $this->convenio;
    }

    /**
     * @param string $convenio
     *
     * @return $this
     */
    public function setConvenio($convenio)
    {
        $this->convenio = $convenio;

        return $this;
    }

     /**
     * @return string
     */
    public function getAgencia()
    {
        return $this->agencia;
    }

    /**
     * @param string $agencia
     *
     * @return $this
     */
    public function setAgencia($agencia)
    {
        $this->agencia = ltrim(trim($agencia, ' '), '0');

        return $this;
    }

    /**
     * @return string
     */
    public function getAgenciaDv()
    {
        return $this->agenciaDv;
    }

    /**
     * @param string $agenciaDv
     *
     * @return $this
     */
    public function setAgenciaDv($agenciaDv)
    {
        $this->agenciaDv = $agenciaDv;

        return $this;
    }

    /**
     * @return string
     */
    public function getConta()
    {
        return $this->conta;
    }

    /**
     * @param string $conta
     *
     * @return $this
     */
    public function setConta($conta)
    {
        $this->conta = ltrim(trim($conta, ' '), '0');

        return $this;
    }

      /**
     * @return string
     */
    public function getContaDv()
    {
        return $this->contaDv;
    }

    /**
     * @param string $contaDv
     *
     * @return $this
     */
    public function setContaDv($contaDv)
    {
        $this->contaDv = $contaDv;

        return $this;
    }

     /**
     * @return string
     */
    public function getNomeEmpresa()
    {
        return $this->nomeEmpresa;
    }

    /**
     * @param string $nomeEmpresa
     *
     * @return $this
     */
    public function setNomeEmpresa($nomeEmpresa)
    {
        $this->nomeEmpresa = $nomeEmpresa;

        return $this;
    }

     /**
     * @return string
     */
    public function getNomeBanco()
    {
        return $this->nomeBanco;
    }

    /**
     * @param string $nomeBanco
     *
     * @return $this
     */
    public function setNomeBanco($nomeBanco)
    {
        $this->nomeBanco = $nomeBanco;

        return $this;
    }

    /**
     * @return int
     */
    public function getCodigoRemessaRetorno()
    {
        return $this->codigoRemessaRetorno;
    }

    /**
     * @param int $codigoRemessaRetorno
     *
     * @return $this
     */
    public function setCodigoRemessaRetorno($codigoRemessaRetorno)
    {
        $this->codigoRemessaRetorno = $codigoRemessaRetorno;

        return $this;
    }

    // /**
    //  * @param string $format
    //  *
    //  * @return string
    //  */
    // public function getData($format = 'd/m/Y')
    // {
    //     return $this->data instanceof Carbon
    //         ? $format === false ? $this->data : $this->data->format($format)
    //         : null;
    // }

    // /**
    //  * @param string $data
    //  *
    //  * @param string $format
    //  *
    //  * @return $this
    //  */
    // public function setData($data, $format = 'dmY')
    // {
    //     $this->data = trim($data, '0 ') ? Carbon::createFromFormat($format, $data) : null;

    //     return $this;
    // }

     /**
     * @param string 
     */
    public function getData()
    {
        return $this->data;
    }

    /**
     * @param $data
     *
     * @return $this
     */
    public function setData($data)
    {
        $this->data = date_format(date_create_from_format('dmY', $data), 'd/m/Y');;

        return $this;
    }

     /**
     * @param string 
     */
    public function gethora()
    {
        return $this->hora;
    }

    /**
     * @param $hora
     *
     * @return $this
     */
    public function setHora($hora)
    {
        $this->hora = date_format(date_create_from_format('His', $hora), 'H:i:s');;

        return $this;
    }

    /**
     * @return string
     */
    public function getNumeroSequencialArquivo()
    {
        return $this->numeroSequencialArquivo;
    }

    /**
     *
     * @param string $numeroSequencialArquivo
     * @return $this
     */
    public function setNumeroSequencialArquivo($numeroSequencialArquivo)
    {
        $this->numeroSequencialArquivo = $numeroSequencialArquivo;

        return $this;
    }

    /**
     * @return string
     */
    public function getVersaoLayoutArquivo()
    {
        return $this->versaoLayoutArquivo;
    }

    /**
     * @param string $versaoLayoutArquivo
     *
     * @return $this
     */
    public function setVersaoLayoutArquivo($versaoLayoutArquivo)
    {
        $this->versaoLayoutArquivo = $versaoLayoutArquivo;

        return $this;
    }
  

    // /**
    //  * @return string
    //  */
    // public function getHoraGeracao()
    // {
    //     return $this->horaGeracao;
    // }

    // /**
    //  * @param string $horaGeracao
    //  *
    //  * @return $this
    //  */
    // public function setHoraGeracao($horaGeracao)
    // {
    //     $this->horaGeracao = $horaGeracao;

    //     return $this;
    // }

    

    

   

    

  

    


    

    

   
}
